Package org.apache.sling.pipes

## Class AbstractInputStreamPipe

- java.lang.Object
- - org.apache.sling.pipes.BasePipe
  - - org.apache.sling.pipes.AbstractInputStreamPipe

All Implemented Interfaces:
  `Pipe`

Direct Known Subclasses:
  `CsvPipe`, `JsonPipe`, `RegexpPipe`

    public abstract class AbstractInputStreamPipe
    extends BasePipe

Input Stream based pipe, coming from web, from request, resource tree, web binding is updated by the returned iterator

### Field Summary

Fields
`protected Object` `binding`
`static String` `BINDING_IS`
`static String` `REMOTE_START`
`protected static Pattern` `VALID_PATH`

### Fields inherited from class org.apache.sling.pipes.BasePipe

`afterHook, beforeHook, bindingProviders, bindings, distributionAgent, DRYRUN_EXPR, DRYRUN_KEY, EMPTY_ITERATOR, IGNORED_NODES, IGNORED_PROPERTIES, parent, plumber, PN_AFTERHOOK, PN_BEFOREHOOK, PN_STATUS, PN_STATUS_MODIFIED, properties, READ_ONLY, resolver, resource, RESOURCE_TYPE, RT_PREFIX, SLASH, STATUS_FINISHED, STATUS_STARTED`

### Fields inherited from interface org.apache.sling.pipes.Pipe

`NN_CONF, PN_DISTRIBUTION_AGENT, PN_EXPR, PN_NAME, PN_PATH`

### Constructor Summary

Constructors
`AbstractInputStreamPipe​(Plumber plumber, org.apache.sling.api.resource.Resource resource, PipeBindings upperBindings)`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`void` `after()` to be executed before output is retrieved
`Iterator<org.apache.sling.api.resource.Resource>` `computeOutput()`
`abstract Iterator<org.apache.sling.api.resource.Resource>` `getOutput​(InputStream inputStream)`
`Object` `getOutputBinding()` returns the binding output used in container pipe's expression

### Methods inherited from class org.apache.sling.pipes.BasePipe

`before, getBindings, getComputedPath, getConfiguration, getDistributionAgent, getExpr, getInput, getName, getOutput, getParent, getPath, getPreviousPipe, getPreviousResource, getRawExpression, getRawPath, getResource, isDryRun, isRootPath, modifiesContent, provideAdditionalBindings, setParent, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### REMOTE_START

    public static final String REMOTE_START

See Also:
  Constant Field Values

#### VALID_PATH

    protected static final Pattern VALID_PATH

#### BINDING_IS

    public static final String BINDING_IS

See Also:
  Constant Field Values

#### binding

    protected Object binding

### Constructor Detail

#### AbstractInputStreamPipe

    public AbstractInputStreamPipe​(Plumber plumber,
                                   org.apache.sling.api.resource.Resource resource,
                                   PipeBindings upperBindings)

### Method Detail

#### getOutputBinding

    public Object getOutputBinding()

Description copied from interface: `Pipe`
returns the binding output used in container pipe's expression

Specified by:
  `getOutputBinding` in interface `Pipe`
Overrides:
  `getOutputBinding` in class `BasePipe`
Returns:
  object, either value map or something else, that will be used in nashorn for computing expressions

#### getOutput

    public abstract Iterator<org.apache.sling.api.resource.Resource> getOutput​(InputStream inputStream)

#### computeOutput

    public Iterator<org.apache.sling.api.resource.Resource> computeOutput()

Overrides:
  `computeOutput` in class `BasePipe`
Returns:
  outputs of the pipe, as an iterator of resources

#### after

    public void after()

Description copied from interface: `Pipe`
to be executed before output is retrieved

Specified by:
  `after` in interface `Pipe`
Overrides:
  `after` in class `BasePipe`